/**
 * Created by IntelliJ IDEA.
 * User: Scalldog
 * Date: Oct 9, 2003
 * Time: 6:12:46 PM
 *
 * Copyright (C) 2003 Fredrik Rydn & Tobias Larsson
 * Full copyright statement can be found in JavaBot.java
 */
package javabot.modules;

import javabot.Module;

import java.net.Socket;
import java.io.DataOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Vector;

public class SwedishTv2 extends Module {
    public void runModule() {
        int argumentsStartAt = getArgumentsStartPosition();
        String[] message = getMessage();
        Vector websiteVector = downloadWebsite();
        String ircOutput = "";
        String description = "";
        if (websiteVector != null) {
            if (message[argumentsStartAt - 1].indexOf("!tv") > -1) {
                if (scanWebsite(websiteVector,"svt1.gif","SVT1") != null) {
                    ircOutput += scanWebsite(websiteVector,"svt1.gif","SVT1")[0];
                }
                if (scanWebsite(websiteVector,"svt2.gif","SVT2") != null) {
                    ircOutput += scanWebsite(websiteVector,"svt2.gif","SVT2")[0];
                }
                if (scanWebsite(websiteVector,"tv3.gif","TV3") != null) {
                    ircOutput += scanWebsite(websiteVector,"tv3.gif","TV3")[0];
                }
                if (scanWebsite(websiteVector,"tv4.gif","TV4") != null) {
                    ircOutput += scanWebsite(websiteVector,"tv4.gif","TV4")[0];
                }
                if (scanWebsite(websiteVector,"kanal5.gif","Kanal 5") != null) {
                    ircOutput += scanWebsite(websiteVector,"kanal5.gif","Kanal 5")[0];
                }
                if (scanWebsite(websiteVector,"ztv.gif","ZTV") != null) {
                    ircOutput += scanWebsite(websiteVector,"ztv.gif","ZTV")[0];
                }
                getSecretary().sendRawIRCMessage("PRIVMSG " + message[2] + " :" + ircOutput);
                ircOutput = "";
            }
            else if (message[argumentsStartAt - 1].indexOf("!discovery") > -1) {
                if (scanWebsite(websiteVector,"discovery.gif","Discovery Channel") != null) {
                       ircOutput += scanWebsite(websiteVector,"discovery.gif","Discovery Channel")[0];
                  }
                if (scanWebsite(websiteVector,"discoverycivilisation.gif","Discovery Civilisation") != null) {
                    ircOutput += scanWebsite(websiteVector,"discoverycivilisation.gif","Discovery Civilisation")[0];
                }
                if (scanWebsite(websiteVector,"discoveryscitrek.gif","Discovery Science") != null) {
                    ircOutput += scanWebsite(websiteVector,"discoveryscitrek.gif","Discovery Science")[0];
                }
                if (scanWebsite(websiteVector,"discoverytraveladventure.gif","Discovery T & A") != null) {
                    ircOutput += scanWebsite(websiteVector,"discoverytraveladventure.gif","Discovery T & A")[0];
                }
                if (scanWebsite(websiteVector,"animalplanet.gif","Animal Planet") != null) {
                    ircOutput += scanWebsite(websiteVector,"animalplanet.gif","Animal Planet")[0];
                }
                getSecretary().sendRawIRCMessage("PRIVMSG " + message[2] + " :" + ircOutput);
                ircOutput = "";
            }
            else if(message[argumentsStartAt-1].indexOf("!moreinfo") > -1) {
                String programme = getRawIRCMessage().substring(getRawIRCMessage().indexOf(message[argumentsStartAt - 1]) + 11,getRawIRCMessage().length());
                if (programme.equalsIgnoreCase("SVT1") && scanWebsite(websiteVector,"svt1.gif","SVT1") != null) {
                    description = scanWebsite(websiteVector,"svt1.gif","SVT1")[1];
                    programme = "SVT1";
                }
                else  if (programme.equalsIgnoreCase("SVT2") && scanWebsite(websiteVector,"svt2.gif","SVT2") != null) {
                    description = scanWebsite(websiteVector,"svt2.gif","SVT2")[1];
                    programme = "SVT2";
                }
                else  if (programme.equalsIgnoreCase("TV3") && scanWebsite(websiteVector,"tv3.gif","TV3") != null) {
                    description = scanWebsite(websiteVector,"tv3.gif","TV3")[1];
                    programme = "TV3";
                }
                else  if (programme.equalsIgnoreCase("TV4") && scanWebsite(websiteVector,"tv4.gif","TV4") != null) {
                    description = scanWebsite(websiteVector,"tv4.gif","TV4")[1];
                    programme = "TV4";
                }
                else  if (programme.equalsIgnoreCase("Kanal 5") && scanWebsite(websiteVector,"kanal5.gif","Kanal 5") != null) {
                    description = scanWebsite(websiteVector,"kanal5.gif","Kanal 5")[1];
                    programme = "Kanal 5";
                }
                else  if (programme.equalsIgnoreCase("ZTV") && scanWebsite(websiteVector,"ztv.gif","ZTV") != null) {
                    description = scanWebsite(websiteVector,"ztv.gif","ZTV")[1];
                    programme = "ZTV";
                }
                else  if (programme.equalsIgnoreCase("Discovery Channel") && scanWebsite(websiteVector,"discovery.gif","Discovery Channel") != null) {
                    description = scanWebsite(websiteVector,"discovery.gif","Discovery Channel")[1];
                    programme = "Discovery Channel";
                }
                else  if (programme.equalsIgnoreCase("Discovery Civilisation") && scanWebsite(websiteVector,"discoverycivilisation.gif","Discovery Civilisation") != null) {
                    description = scanWebsite(websiteVector,"discoverycivilisation.gif","Discovery Civilisation")[1];
                    programme = "Discovery Civilisation";
                }
                else  if (programme.equalsIgnoreCase("Discovery Science") && scanWebsite(websiteVector,"discoveryscitrek.gif","Discovery Science") != null) {
                    description = scanWebsite(websiteVector,"discoveryscitrek.gif","Discovery Science")[1];
                    programme = "Discovery Science";
                }
                else  if (programme.equalsIgnoreCase("Discovery T & A") && scanWebsite(websiteVector,"discoverytraveladventure.gif","Discovery T & A") != null) {
                    description = scanWebsite(websiteVector,"discoverytraveladventure.gif","Discovery T & A")[1];
                    programme = "Discovery T & A";
                }
                else  if (programme.equalsIgnoreCase("Animal Planet") && scanWebsite(websiteVector,"animalplanet.gif","Animal Planet") != null) {
                    description = scanWebsite(websiteVector,"animalplanet.gif","Animal Planet")[1];
                    programme = "Animal Planet";
                }
                if (description.equalsIgnoreCase("")) {
                    description = "No description could be given for that programme";
                }
                getSecretary().sendRawIRCMessage("PRIVMSG " + message[2] + " :Description for " + programme + ": " + description);
                programme = "";
            }
        }
    }
    public Vector downloadWebsite() {
        Vector websiteVector = new Vector();

        try {
            Socket connectionSocket = null;
            DataOutputStream out = null;
            BufferedReader in = null;
            connectionSocket = new Socket("tv.op.se",80);
            out = new DataOutputStream(connectionSocket.getOutputStream());
            out.writeBytes("GET /se/chart/?now=1 HTTP/1.1\nHost: tv.op.se\nConnection: close\nUser-agent: Mozilla/4.0\n\n");
            in = new BufferedReader(new InputStreamReader(connectionSocket.getInputStream()));
            String currentLine = "";

            while (currentLine != null) {
                websiteVector.add(currentLine);
                currentLine = in.readLine();
            }
        }
        catch(IOException e) {
            return null;
        }
    return websiteVector;
    }

    public String[] scanWebsite(Vector websiteVector,String gifFile,String kanal) {
        String[] arrayToReturn = new String[2];
        String programmeStartsAt = "";
        String programmeEndsAt = "";
        String programmeLine = "";
        String programmeDescription = "";
        if (websiteVector != null) {
            for (int i = 1;i < websiteVector.size();i++) {
                String vectorElement = (String)websiteVector.elementAt(i);
                if (vectorElement.indexOf("<img src=\"/shared/logos/" + gifFile + "\" alt=\"" + kanal + "\" border=\"0\" vspace=\"0\" hspace=\"0\">") > -1) {
                    programmeStartsAt = (String)websiteVector.elementAt(i + 5);

                    programmeStartsAt = programmeStartsAt.substring(programmeStartsAt.indexOf("<td class=\"charttime\" valign=\"top\" width=\"40\">") + 46, programmeStartsAt.indexOf("</td>"));

                    programmeLine = (String)websiteVector.elementAt(i + 9);

                    programmeLine = programmeLine.trim();
                    programmeLine = programmeLine.substring(0,programmeLine.indexOf("</span>"));
                    programmeLine = replaceUglyHtmlChars(programmeLine);

                    programmeEndsAt = (String)websiteVector.elementAt(i + 9);
                    programmeEndsAt = programmeEndsAt.trim();
                    programmeEndsAt = programmeEndsAt.substring(programmeEndsAt.indexOf("</span> (") + 9,programmeEndsAt.indexOf(")"));

                    programmeDescription = " " + (char)2 + programmeLine + " (" + programmeStartsAt + " - " + programmeEndsAt + ") " + (char)2;

                    String chartDescriptionLine = (String)websiteVector.elementAt(i + 10);
                    if (chartDescriptionLine.indexOf("<br><span class=\"chartdescription\">") > -1) {
                        programmeDescription = (String)websiteVector.elementAt(i + 11);
                        programmeDescription = programmeDescription.trim();
                        programmeDescription = replaceUglyHtmlChars(programmeDescription);
                        programmeDescription = (char)2 + programmeLine + " (" + programmeStartsAt + " - " + programmeEndsAt + ") " + (char)2 + programmeDescription;
                        programmeLine += " (i)";
                    }

                    arrayToReturn[0] = (char)2 + kanal + ":" + (char)2 + " " + programmeStartsAt + " - " + programmeLine + " ";
                    arrayToReturn[1] = programmeDescription;
                    return arrayToReturn;

                }

            }
        }
        else {
            return null;
        }

    return null;}

    private String replaceUglyHtmlChars(String program)
    {
        program = program.replaceAll("&#228;", "");
        program = program.replaceAll("&#196;", "");
        program = program.replaceAll("&#229;", "");
        program = program.replaceAll("&#197;", "");
        program = program.replaceAll("&#214;", "");
        program = program.replaceAll("&#246;", "");
        program = program.replaceAll("&amp;", "&");
        program = program.replaceAll("&nbsp;", " ");
        program = program.replaceAll("&#220;", "");
        program = program.replaceAll("&#252;", "");
        program = program.replaceAll("&#233;", "");
        program = program.replaceAll("&quot;", "\"");

        return program;
    }


    public String[] getCommands()
    {
        String[] commands = {"!tv","!moreinfo","!discovery"};
        return commands;
    }

    public void gotResponse(String[] response, String[] thingsToRemember)
    {
    }

    public void timerExpired(String[] thingsToRemember)
    {
    }

    public String getHelpMessage()
    {
        return "Shows what's on swedish television at the moment. Usage: !tv (for the normal swedish channels), !discovery (for the discovery channels), !moreinfo <channel> (receive some more info about the programme)";
    }

    public String getGroupName()
    {
        return "InfoModules";
    }
}
